#include <ecf/ECF.h>
#include <vector>
#include "genotip.h"
using namespace std;

void NoteVector::registerParameters(StateP state) {
	int *sizep = new int(duljina_);
	state->getRegistry()->registerEntry(name_ + ".size", (voidP) sizep, UINT, genotypeId_);
}

bool NoteVector::initialize(StateP state) {
	RandomizerP randomizer = state->getRandomizer();

	note.resize(duljina_);
	note[0]          = pocetna[ randomizer->getRandomInteger(0, 3) ];
	note[duljina_-1] = pocetna[ randomizer->getRandomInteger(0, 3) ];

	for (uint i = 1; i < duljina_-1; ++i)
		note[i] = randomizer->getRandomInteger(0, upper_note);

	return true;
}

vector<CrossoverOpP> NoteVector::getCrossoverOp() {
	vector<CrossoverOpP> crx;
	crx.push_back( static_cast<CrossoverOpP> (new NoteVectorCrossover) );
	return crx;
}

vector<MutationOpP> NoteVector::getMutationOp() {
	vector<MutationOpP> mut;
	mut.push_back( static_cast<MutationOpP> (new NoteVectorMutation) );
	return mut;
}

void NoteVector::write(XMLNode &node) {
	node = XMLNode::createXMLTopNode("NoteVector");
	stringstream ss;

	ss << duljina_;
	node.addAttribute("size", ss.str().c_str());
	ss.str("");
	for (uint i = 0; i < duljina_; ++i)
		ss << noteNames[ (int)n[(int)note[i]] ] << " ";

	node.addText(ss.str().c_str());
}

const char NoteVector::n[] = { 
	0, 2, 3, 5, 7, 8, 10, 12, 14, 15, 17, 19, 20, 22 
};

const string NoteVector::noteNames[] = {
	"a1", "a#1'", "h1", "c1", "c#1", "d1", "d#1", "e1", "f1", "f#1", "g1", 
	"g#1", "a1", "a#1", "h1", "c2", "c#2", "d2", "d#2", "e2", "f2",
       	"f#2", "g2"
};

// pocetna i zavrsna nota mogu biti a1, c1, e1 ili a2
const char NoteVector::pocetna[] = { 
	0, 2, 4, 7 
};

