#ifndef __MOZART_GENOTIP_H
#define __MOZART_GENOTIP_H

#include <ecf/ECF.h>
#include <vector>
#include "operatori.h"
using namespace std;

/**
 * NoteVector klasa predstavlja niz nota. Note se oznacavaju brojem polutonova
 * od a1, te su u intervalu od 0 (a1) do 22 (g2).
 */
class NoteVector : public Genotype {
private:
	static const char pocetna[];
public:
	static const char n[];
	static const char upper_note = 13;
	static const string noteNames[];

	vector<char> note;
	uint duljina_;

	NoteVector(uint duljina = 16) {
		name_    = "NoteVector";
		duljina_ = duljina;
	}

	void registerParameters(StateP state);
	bool initialize(StateP state);
	void write(XMLNode &node);
	vector<CrossoverOpP> getCrossoverOp();
	vector<MutationOpP> getMutationOp();
	NoteVector *copy() { return new NoteVector(*this); }
};

#endif
