#ifndef __MOZART_OPERATORI_H
#define __MOZART_OPERATORI_H

#include <ecf/ECF.h>

/**
 * Operator krizanja za genotip NoteVector - one point crossover
 */
class NoteVectorCrossover : public CrossoverOp {
public:
        bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
};

/**
 * Operator mutacije za genotip NoteVector
 * poveca ili smanji pojedinu notu za jedan/pola tona
 */
class NoteVectorMutation : public MutationOp {
public:
        bool mutate(GenotypeP gene);
};

/**
 * Operator za evaluaciju jedinke
 * Evaluacija se vrsi tako da se svakom melodijskom intervalu pridijeli
 * odredjeni skor.
 */
class NoteVectorEval : public EvaluateOp {
private:
	static const int score[];
public:
	FitnessP evaluate(IndividualP individual);
};

#endif
